package  {

import flash.display.Sprite;
import flash.events.MouseEvent;

public class Node extends Sprite {
	
	private var _state:Boolean;
	private var _id:uint;
	
	public function Node()
	{
		super();
		
		graphics.clear();

		graphics.beginFill(uint(!_state)*0xffffff);

        graphics.lineStyle(1);
		graphics.drawRect(0, 0, Main.NODE_WIDTH, Main.NODE_WIDTH);
		graphics.endFill();
		
		addEventListener(MouseEvent.CLICK, flipState);
	}
	
	public function get id():uint
	{ 
		return _id; 
	}

	public function set id(value:uint):void
	{
		_id = value;
	}
	
	public function get state():Boolean
	{ 
		return _state; 
	}

	public function set state(value:Boolean):void
	{
		if(value != _state){
			_state = value;
			
			graphics.clear();

			graphics.beginFill(uint(!_state)*0xffffff);

	        graphics.lineStyle(1);
			graphics.drawRect(0, 0, Main.NODE_WIDTH, Main.NODE_WIDTH);
			graphics.endFill();
		}
	}
	
	
	private function flipState(event:MouseEvent):void
	{
		state = !state;
		Main.setNodeState(this);
	};
	
}

}

